質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

90.61%

  • Python 3.x

    5896questions

    Python 3はPythonプログラミング言語の最新バージョンであり、2008年12月3日にリリースされました。

  • Django

    983questions

    DjangoはPythonで書かれた、オープンソースウェブアプリケーションのフレームワークです。複雑なデータベースを扱うウェブサイトを開発する際に必要な労力を減らす為にデザインされました。

Djangoで初期のmigrateが出来ない。(`disk I/O error`)

解決済

回答 1

投稿 編集

  • 評価
  • クリップ 0
  • VIEW 291

hnkyi

score 8

 事象

タイトルの通りです。
Djangoで新規プロジェクトを作成し、初期のmigrateをすると、`disk I/O error)が発生します。

元々ローカルで開発を行っており、あらかた動いたのでクラウド環境に移そうと考えていました。

移す前に、クラウド環境でdjangoプロジェクトが作れて実行確認できるか試したところ、今回の事象が発生しました。

 環境

当該事象が発生するクラウド環境は以下の通りです。

$ cat /etc/redhat-release 
CentOS Linux release 7.5.1804 (Core) 

$ python -V
Python 3.6.5

$ pip list | grep Django
Django (2.0.5)

$ sqlite3 -version
3.7.17 2013-05-20 00:56:22 118a3b35693b134d56ebd780123b7fd6f1497668

 手順

大きく2つの手順を試しました。

  • いきなりmigrateをする
  • makemigtationsをしてから、migrateをする

前述した通り、どちらの手順でもdisk I/O errorという不穏なエラーが発生します...

 ①いきなりmigrate

# djangoプロジェクトを新規作成
$ django-admin startproject dummy

# 移動
$ cd dummy

# マイグレーション
$ python manage.py migrate
Operations to perform:
  Apply all migrations: admin, auth, contenttypes, sessions
Running migrations:
Traceback (most recent call last):
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/db/backends/base/base.py", line 239, in _commit
    return self.connection.commit()
sqlite3.OperationalError: disk I/O error

The above exception was the direct cause of the following exception:

Traceback (most recent call last):
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/db/migrations/recorder.py", line 55, in ensure_schema
    editor.create_model(self.Migration)
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/db/backends/sqlite3/schema.py", line 28, in __exit__
    super().__exit__(exc_type, exc_value, traceback)
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/db/backends/base/schema.py", line 108, in __exit__
    self.atomic.__exit__(exc_type, exc_value, traceback)
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/db/transaction.py", line 212, in __exit__
    connection.commit()
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/db/backends/base/base.py", line 261, in commit
    self._commit()
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/db/backends/base/base.py", line 239, in _commit
    return self.connection.commit()
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/db/utils.py", line 89, in __exit__
    raise dj_exc_value.with_traceback(traceback) from exc_value
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/db/backends/base/base.py", line 239, in _commit
    return self.connection.commit()
django.db.utils.OperationalError: disk I/O error

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "manage.py", line 15, in <module>
    execute_from_command_line(sys.argv)
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/core/management/__init__.py", line 371, in execute_from_command_line
    utility.execute()
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/core/management/__init__.py", line 365, in execute
    self.fetch_command(subcommand).run_from_argv(self.argv)
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/core/management/base.py", line 288, in run_from_argv
    self.execute(*args, **cmd_options)
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/core/management/base.py", line 335, in execute
    output = self.handle(*args, **options)
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/core/management/commands/migrate.py", line 200, in handle
    fake_initial=fake_initial,
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/db/migrations/executor.py", line 91, in migrate
    self.recorder.ensure_schema()
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/db/migrations/recorder.py", line 57, in ensure_schema
    raise MigrationSchemaMissing("Unable to create the django_migrations table (%s)" % exc)
django.db.migrations.exceptions.MigrationSchemaMissing: Unable to create the django_migrations table (disk I/O error)

 ②makemigrationsしてから、migrate

# djangoプロジェクトを新規作成
$ django-admin startproject dummy

# 移動
$ cd dummy

# マイグレーション
$ python manage.py makemigrations
No changes detected
$ 
$ python manage.py migrate
Operations to perform:
  Apply all migrations: admin, auth, contenttypes, sessions
Running migrations:
  Applying contenttypes.0001_initial...Traceback (most recent call last):
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/db/backends/base/base.py", line 239, in _commit
    return self.connection.commit()
sqlite3.OperationalError: disk I/O error

The above exception was the direct cause of the following exception:

Traceback (most recent call last):
  File "manage.py", line 15, in <module>
    execute_from_command_line(sys.argv)
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/core/management/__init__.py", line 371, in execute_from_command_line
    utility.execute()
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/core/management/__init__.py", line 365, in execute
    self.fetch_command(subcommand).run_from_argv(self.argv)
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/core/management/base.py", line 288, in run_from_argv
    self.execute(*args, **cmd_options)
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/core/management/base.py", line 335, in execute
    output = self.handle(*args, **options)
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/core/management/commands/migrate.py", line 200, in handle
    fake_initial=fake_initial,
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/db/migrations/executor.py", line 117, in migrate
    state = self._migrate_all_forwards(state, plan, full_plan, fake=fake, fake_initial=fake_initial)
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/db/migrations/executor.py", line 147, in _migrate_all_forwards
    state = self.apply_migration(state, migration, fake=fake, fake_initial=fake_initial)
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/db/migrations/executor.py", line 244, in apply_migration
    state = migration.apply(state, schema_editor)
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/db/backends/sqlite3/schema.py", line 28, in __exit__
    super().__exit__(exc_type, exc_value, traceback)
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/db/backends/base/schema.py", line 108, in __exit__
    self.atomic.__exit__(exc_type, exc_value, traceback)
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/db/transaction.py", line 212, in __exit__
    connection.commit()
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/db/backends/base/base.py", line 261, in commit
    self._commit()
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/db/backends/base/base.py", line 239, in _commit
    return self.connection.commit()
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/db/utils.py", line 89, in __exit__
    raise dj_exc_value.with_traceback(traceback) from exc_value
  File "/root/.virtualenvs/env1/lib/python3.6/site-packages/django/db/backends/base/base.py", line 239, in _commit
    return self.connection.commit()
django.db.utils.OperationalError: disk I/O error

 試した事

 SQLiteのバージョンアップ

ローカルで動いていたバージョン(3.19.3)や、最新版(3.23.1)に変更してみましたが、同様の事象となりました。

 SQLiteへの接続

普通に繋がりました。

テーブルは、①の時はdjango_migrationsだけ、②の時はdjango_content_typedjango_migrationsだけあるような状況。

以下、接続状況。

$ sqlite3 db.sqlite3 
SQLite version 3.7.17 2013-05-20 00:56:22
Enter ".help" for instructions
Enter SQL statements terminated with a ";"
sqlite> 
sqlite> .tables
django_content_type  django_migrations  

 SQLiteへのCreate table/Insert/Select

@hayataka2049 様からの質問を受け、試しましたところ、手動でのCreate table/Insert/Selectは正常に処理できました。

$ sqlite3 db.sqlite3 
SQLite version 3.7.17 2013-05-20 00:56:22
Enter ".help" for instructions
Enter SQL statements terminated with a ";"
sqlite> 
sqlite> create table dummy (id, name);
sqlite> .tables
django_migrations  django_session     dummy            
sqlite> 
sqlite> insert into dummy (id, name) values (1, 'hoge');
sqlite> 
sqlite> select * from dummy;
1|hoge

その他諸々、一日かけて調べて分からなかったため、tetatailにて質問させていただく事にしました。
よろしくお願い致します。


Teratailの文字数制限のせいで、書きたい情報が書けなかったので、Qiitaにも同じの書きました。
こちらも参考にしていただけると幸いです。
https://qiita.com/hnkyi/items/5f00d9eb5d7a91ef0b59

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

質問への追記・修正、ベストアンサー選択の依頼

  • hnkyi

    2018/05/18 16:34

    他のプロセスは動かしてないので、それはないと思われます...

    キャンセル

  • hnkyi

    2018/05/18 17:15

    SQLiteのオートコミットってどうやって外すかご存知でしょうか...??

    キャンセル

  • hnkyi

    2018/05/18 17:52

    解決しました!SELinuxがdisabledになってない場合に発生する事があるそうです。お騒がせしました...=> https://stackoverflow.com/questions/29244788/error-disk-i-o-error-on-a-newly-created-database

    キャンセル

回答 1

check解決した方法

0

自己解決しました。

SELinuxがdisabledになっていない場合に、当該事象が発生する事があるようです。

https://stackoverflow.com/questions/29244788/error-disk-i-o-error-on-a-newly-created-database

getenforceで確認してdisabledだったので安心してたのですが、
再起動しないと反映されない事を忘れてました。
(いつdisabledになっていて、再起動してなかったのかは定かではないのですが...)

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 90.61%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

関連した質問

同じタグがついた質問を見る

  • Python 3.x

    5896questions

    Python 3はPythonプログラミング言語の最新バージョンであり、2008年12月3日にリリースされました。

  • Django

    983questions

    DjangoはPythonで書かれた、オープンソースウェブアプリケーションのフレームワークです。複雑なデータベースを扱うウェブサイトを開発する際に必要な労力を減らす為にデザインされました。